/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml13.behavioral_elements.activity_graphs.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.InternalEList;

import fr.obeo.acceleo.uml13.behavioral_elements.activity_graphs.Activity_graphsPackage;
import fr.obeo.acceleo.uml13.behavioral_elements.activity_graphs.SubactivityState;
import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Action;
import fr.obeo.acceleo.uml13.behavioral_elements.state_machines.CompositeState;
import fr.obeo.acceleo.uml13.behavioral_elements.state_machines.StateMachine;
import fr.obeo.acceleo.uml13.behavioral_elements.state_machines.State_machinesPackage;
import fr.obeo.acceleo.uml13.behavioral_elements.state_machines.impl.SubmachineStateImpl;
import fr.obeo.acceleo.uml13.foundation.core.Binding;
import fr.obeo.acceleo.uml13.foundation.core.CorePackage;
import fr.obeo.acceleo.uml13.foundation.core.Namespace;
import fr.obeo.acceleo.uml13.foundation.data_types.ArgListsExpression;
import fr.obeo.acceleo.uml13.foundation.data_types.Multiplicity;
import fr.obeo.acceleo.uml13.foundation.extension_mechanisms.Extension_mechanismsPackage;
import fr.obeo.acceleo.uml13.foundation.extension_mechanisms.Stereotype;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>Subactivity State</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>{@link fr.obeo.acceleo.uml13.behavioral_elements.activity_graphs.impl.SubactivityStateImpl#isIsDynamic <em>Is Dynamic</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.behavioral_elements.activity_graphs.impl.SubactivityStateImpl#getDynamicArguments <em>Dynamic Arguments</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.behavioral_elements.activity_graphs.impl.SubactivityStateImpl#getDynamicMultiplicity <em>Dynamic Multiplicity</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class SubactivityStateImpl extends SubmachineStateImpl implements SubactivityState {
	/**
	 * The default value of the '{@link #isIsDynamic() <em>Is Dynamic</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #isIsDynamic()
	 * @generated
	 * @ordered
	 */
	protected static final boolean IS_DYNAMIC_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isIsDynamic() <em>Is Dynamic</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #isIsDynamic()
	 * @generated
	 * @ordered
	 */
	protected boolean isDynamic = IS_DYNAMIC_EDEFAULT;

	/**
	 * The cached value of the '{@link #getDynamicArguments() <em>Dynamic Arguments</em>}'
	 * containment reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getDynamicArguments()
	 * @generated
	 * @ordered
	 */
	protected ArgListsExpression dynamicArguments = null;

	/**
	 * The cached value of the '{@link #getDynamicMultiplicity() <em>Dynamic Multiplicity</em>}'
	 * containment reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getDynamicMultiplicity()
	 * @generated
	 * @ordered
	 */
	protected Multiplicity dynamicMultiplicity = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected SubactivityStateImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected EClass eStaticClass() {
		return Activity_graphsPackage.eINSTANCE.getSubactivityState();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean isIsDynamic() {
		return isDynamic;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setIsDynamic(boolean newIsDynamic) {
		boolean oldIsDynamic = isDynamic;
		isDynamic = newIsDynamic;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Activity_graphsPackage.SUBACTIVITY_STATE__IS_DYNAMIC, oldIsDynamic, isDynamic));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public ArgListsExpression getDynamicArguments() {
		return dynamicArguments;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetDynamicArguments(ArgListsExpression newDynamicArguments, NotificationChain msgs) {
		ArgListsExpression oldDynamicArguments = dynamicArguments;
		dynamicArguments = newDynamicArguments;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Activity_graphsPackage.SUBACTIVITY_STATE__DYNAMIC_ARGUMENTS, oldDynamicArguments, newDynamicArguments);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setDynamicArguments(ArgListsExpression newDynamicArguments) {
		if (newDynamicArguments != dynamicArguments) {
			NotificationChain msgs = null;
			if (dynamicArguments != null)
				msgs = ((InternalEObject) dynamicArguments).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - Activity_graphsPackage.SUBACTIVITY_STATE__DYNAMIC_ARGUMENTS, null, msgs);
			if (newDynamicArguments != null)
				msgs = ((InternalEObject) newDynamicArguments).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - Activity_graphsPackage.SUBACTIVITY_STATE__DYNAMIC_ARGUMENTS, null, msgs);
			msgs = basicSetDynamicArguments(newDynamicArguments, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Activity_graphsPackage.SUBACTIVITY_STATE__DYNAMIC_ARGUMENTS, newDynamicArguments, newDynamicArguments));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Multiplicity getDynamicMultiplicity() {
		return dynamicMultiplicity;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetDynamicMultiplicity(Multiplicity newDynamicMultiplicity, NotificationChain msgs) {
		Multiplicity oldDynamicMultiplicity = dynamicMultiplicity;
		dynamicMultiplicity = newDynamicMultiplicity;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Activity_graphsPackage.SUBACTIVITY_STATE__DYNAMIC_MULTIPLICITY, oldDynamicMultiplicity,
					newDynamicMultiplicity);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setDynamicMultiplicity(Multiplicity newDynamicMultiplicity) {
		if (newDynamicMultiplicity != dynamicMultiplicity) {
			NotificationChain msgs = null;
			if (dynamicMultiplicity != null)
				msgs = ((InternalEObject) dynamicMultiplicity).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - Activity_graphsPackage.SUBACTIVITY_STATE__DYNAMIC_MULTIPLICITY, null, msgs);
			if (newDynamicMultiplicity != null)
				msgs = ((InternalEObject) newDynamicMultiplicity).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - Activity_graphsPackage.SUBACTIVITY_STATE__DYNAMIC_MULTIPLICITY, null, msgs);
			msgs = basicSetDynamicMultiplicity(newDynamicMultiplicity, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Activity_graphsPackage.SUBACTIVITY_STATE__DYNAMIC_MULTIPLICITY, newDynamicMultiplicity, newDynamicMultiplicity));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case Activity_graphsPackage.SUBACTIVITY_STATE__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicAdd(otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__NAMESPACE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, Activity_graphsPackage.SUBACTIVITY_STATE__NAMESPACE, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicAdd(otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicAdd(otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicAdd(otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__PRESENTATION:
				return ((InternalEList) getPresentation()).basicAdd(otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicAdd(otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicAdd(otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__TEMPLATE_PARAMETER3:
				return ((InternalEList) getTemplateParameter3()).basicAdd(otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__BINDING:
				if (binding != null)
					msgs = ((InternalEObject) binding).eInverseRemove(this, CorePackage.BINDING__ARGUMENT, Binding.class, msgs);
				return basicSetBinding((Binding) otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__COMMENT:
				return ((InternalEList) getComment()).basicAdd(otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicAdd(otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicAdd(otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__TEMPLATE_PARAMETER2:
				return ((InternalEList) getTemplateParameter2()).basicAdd(otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__STEREOTYPE:
				if (stereotype != null)
					msgs = ((InternalEObject) stereotype).eInverseRemove(this, Extension_mechanismsPackage.STEREOTYPE__EXTENDED_ELEMENT, Stereotype.class, msgs);
				return basicSetStereotype((Stereotype) otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicAdd(otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicAdd(otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicAdd(otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicAdd(otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__PARTITION:
				return ((InternalEList) getPartition()).basicAdd(otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__CONTAINER:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, Activity_graphsPackage.SUBACTIVITY_STATE__CONTAINER, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__OUTGOING:
				return ((InternalEList) getOutgoing()).basicAdd(otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__INCOMING:
				return ((InternalEList) getIncoming()).basicAdd(otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__ENTRY:
				if (entry != null)
					msgs = ((InternalEObject) entry).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - Activity_graphsPackage.SUBACTIVITY_STATE__ENTRY, null, msgs);
				return basicSetEntry((Action) otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__EXIT:
				if (exit != null)
					msgs = ((InternalEObject) exit).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - Activity_graphsPackage.SUBACTIVITY_STATE__EXIT, null, msgs);
				return basicSetExit((Action) otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__STATE_MACHINE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, Activity_graphsPackage.SUBACTIVITY_STATE__STATE_MACHINE, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__DEFERRABLE_EVENT:
				return ((InternalEList) getDeferrableEvent()).basicAdd(otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__INTERNAL_TRANSITION:
				return ((InternalEList) getInternalTransition()).basicAdd(otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__DO_ACTIVITY:
				if (doActivity != null)
					msgs = ((InternalEObject) doActivity).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - Activity_graphsPackage.SUBACTIVITY_STATE__DO_ACTIVITY, null, msgs);
				return basicSetDoActivity((Action) otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__CLASSIFIER_IN_STATE:
				return ((InternalEList) getClassifierInState()).basicAdd(otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__SUBVERTEX:
				return ((InternalEList) getSubvertex()).basicAdd(otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__SUBMACHINE:
				if (submachine != null)
					msgs = ((InternalEObject) submachine).eInverseRemove(this, State_machinesPackage.STATE_MACHINE__SUB_MACHINE_STATE, StateMachine.class, msgs);
				return basicSetSubmachine((StateMachine) otherEnd, msgs);
			default:
				return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case Activity_graphsPackage.SUBACTIVITY_STATE__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicRemove(otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__NAMESPACE:
				return eBasicSetContainer(null, Activity_graphsPackage.SUBACTIVITY_STATE__NAMESPACE, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicRemove(otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicRemove(otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicRemove(otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__PRESENTATION:
				return ((InternalEList) getPresentation()).basicRemove(otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicRemove(otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicRemove(otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__TEMPLATE_PARAMETER3:
				return ((InternalEList) getTemplateParameter3()).basicRemove(otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__BINDING:
				return basicSetBinding(null, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__COMMENT:
				return ((InternalEList) getComment()).basicRemove(otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicRemove(otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicRemove(otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__TEMPLATE_PARAMETER2:
				return ((InternalEList) getTemplateParameter2()).basicRemove(otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__STEREOTYPE:
				return basicSetStereotype(null, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicRemove(otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicRemove(otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicRemove(otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicRemove(otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__PARTITION:
				return ((InternalEList) getPartition()).basicRemove(otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__CONTAINER:
				return eBasicSetContainer(null, Activity_graphsPackage.SUBACTIVITY_STATE__CONTAINER, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__OUTGOING:
				return ((InternalEList) getOutgoing()).basicRemove(otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__INCOMING:
				return ((InternalEList) getIncoming()).basicRemove(otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__ENTRY:
				return basicSetEntry(null, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__EXIT:
				return basicSetExit(null, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__STATE_MACHINE:
				return eBasicSetContainer(null, Activity_graphsPackage.SUBACTIVITY_STATE__STATE_MACHINE, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__DEFERRABLE_EVENT:
				return ((InternalEList) getDeferrableEvent()).basicRemove(otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__INTERNAL_TRANSITION:
				return ((InternalEList) getInternalTransition()).basicRemove(otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__DO_ACTIVITY:
				return basicSetDoActivity(null, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__CLASSIFIER_IN_STATE:
				return ((InternalEList) getClassifierInState()).basicRemove(otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__SUBVERTEX:
				return ((InternalEList) getSubvertex()).basicRemove(otherEnd, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__SUBMACHINE:
				return basicSetSubmachine(null, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__DYNAMIC_ARGUMENTS:
				return basicSetDynamicArguments(null, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__DYNAMIC_MULTIPLICITY:
				return basicSetDynamicMultiplicity(null, msgs);
			default:
				return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
		if (eContainerFeatureID >= 0) {
			switch (eContainerFeatureID) {
			case Activity_graphsPackage.SUBACTIVITY_STATE__NAMESPACE:
				return eContainer.eInverseRemove(this, CorePackage.NAMESPACE__OWNED_ELEMENT, Namespace.class, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__CONTAINER:
				return eContainer.eInverseRemove(this, State_machinesPackage.COMPOSITE_STATE__SUBVERTEX, CompositeState.class, msgs);
			case Activity_graphsPackage.SUBACTIVITY_STATE__STATE_MACHINE:
				return eContainer.eInverseRemove(this, State_machinesPackage.STATE_MACHINE__TOP, StateMachine.class, msgs);
			default:
				return eDynamicBasicRemoveFromContainer(msgs);
			}
		}
		return eContainer.eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Activity_graphsPackage.SUBACTIVITY_STATE__ELEMENT_IMPORT:
			return getElementImport();
		case Activity_graphsPackage.SUBACTIVITY_STATE__NAME:
			return getName();
		case Activity_graphsPackage.SUBACTIVITY_STATE__VISIBILITY:
			return getVisibility();
		case Activity_graphsPackage.SUBACTIVITY_STATE__IS_SPECIFICATION:
			return isIsSpecification() ? Boolean.TRUE : Boolean.FALSE;
		case Activity_graphsPackage.SUBACTIVITY_STATE__NAMESPACE:
			return getNamespace();
		case Activity_graphsPackage.SUBACTIVITY_STATE__CLIENT_DEPENDENCY:
			return getClientDependency();
		case Activity_graphsPackage.SUBACTIVITY_STATE__CONSTRAINT:
			return getConstraint();
		case Activity_graphsPackage.SUBACTIVITY_STATE__SUPPLIER_DEPENDENCY:
			return getSupplierDependency();
		case Activity_graphsPackage.SUBACTIVITY_STATE__PRESENTATION:
			return getPresentation();
		case Activity_graphsPackage.SUBACTIVITY_STATE__TARGET_FLOW:
			return getTargetFlow();
		case Activity_graphsPackage.SUBACTIVITY_STATE__SOURCE_FLOW:
			return getSourceFlow();
		case Activity_graphsPackage.SUBACTIVITY_STATE__TEMPLATE_PARAMETER3:
			return getTemplateParameter3();
		case Activity_graphsPackage.SUBACTIVITY_STATE__BINDING:
			if (resolve)
				return getBinding();
			return basicGetBinding();
		case Activity_graphsPackage.SUBACTIVITY_STATE__COMMENT:
			return getComment();
		case Activity_graphsPackage.SUBACTIVITY_STATE__ELEMENT_RESIDENCE:
			return getElementResidence();
		case Activity_graphsPackage.SUBACTIVITY_STATE__TEMPLATE_PARAMETER:
			return getTemplateParameter();
		case Activity_graphsPackage.SUBACTIVITY_STATE__TEMPLATE_PARAMETER2:
			return getTemplateParameter2();
		case Activity_graphsPackage.SUBACTIVITY_STATE__STEREOTYPE:
			if (resolve)
				return getStereotype();
			return basicGetStereotype();
		case Activity_graphsPackage.SUBACTIVITY_STATE__TAGGED_VALUE:
			return getTaggedValue();
		case Activity_graphsPackage.SUBACTIVITY_STATE__BEHAVIOR:
			return getBehavior();
		case Activity_graphsPackage.SUBACTIVITY_STATE__CLASSIFIER_ROLE:
			return getClassifierRole();
		case Activity_graphsPackage.SUBACTIVITY_STATE__COLLABORATION:
			return getCollaboration();
		case Activity_graphsPackage.SUBACTIVITY_STATE__PARTITION:
			return getPartition();
		case Activity_graphsPackage.SUBACTIVITY_STATE__CONTAINER:
			return getContainer();
		case Activity_graphsPackage.SUBACTIVITY_STATE__OUTGOING:
			return getOutgoing();
		case Activity_graphsPackage.SUBACTIVITY_STATE__INCOMING:
			return getIncoming();
		case Activity_graphsPackage.SUBACTIVITY_STATE__ENTRY:
			return getEntry();
		case Activity_graphsPackage.SUBACTIVITY_STATE__EXIT:
			return getExit();
		case Activity_graphsPackage.SUBACTIVITY_STATE__STATE_MACHINE:
			return getStateMachine();
		case Activity_graphsPackage.SUBACTIVITY_STATE__DEFERRABLE_EVENT:
			return getDeferrableEvent();
		case Activity_graphsPackage.SUBACTIVITY_STATE__INTERNAL_TRANSITION:
			return getInternalTransition();
		case Activity_graphsPackage.SUBACTIVITY_STATE__DO_ACTIVITY:
			return getDoActivity();
		case Activity_graphsPackage.SUBACTIVITY_STATE__CLASSIFIER_IN_STATE:
			return getClassifierInState();
		case Activity_graphsPackage.SUBACTIVITY_STATE__IS_CONCURRENT:
			return isIsConcurrent() ? Boolean.TRUE : Boolean.FALSE;
		case Activity_graphsPackage.SUBACTIVITY_STATE__SUBVERTEX:
			return getSubvertex();
		case Activity_graphsPackage.SUBACTIVITY_STATE__SUBMACHINE:
			if (resolve)
				return getSubmachine();
			return basicGetSubmachine();
		case Activity_graphsPackage.SUBACTIVITY_STATE__IS_DYNAMIC:
			return isIsDynamic() ? Boolean.TRUE : Boolean.FALSE;
		case Activity_graphsPackage.SUBACTIVITY_STATE__DYNAMIC_ARGUMENTS:
			return getDynamicArguments();
		case Activity_graphsPackage.SUBACTIVITY_STATE__DYNAMIC_MULTIPLICITY:
			return getDynamicMultiplicity();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Activity_graphsPackage.SUBACTIVITY_STATE__ELEMENT_IMPORT:
			getElementImport().clear();
			getElementImport().addAll((Collection) newValue);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__NAME:
			setName((String) newValue);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__VISIBILITY:
			setVisibility((String) newValue);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__IS_SPECIFICATION:
			setIsSpecification(((Boolean) newValue).booleanValue());
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__NAMESPACE:
			setNamespace((Namespace) newValue);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			getClientDependency().addAll((Collection) newValue);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__CONSTRAINT:
			getConstraint().clear();
			getConstraint().addAll((Collection) newValue);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			getSupplierDependency().addAll((Collection) newValue);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__PRESENTATION:
			getPresentation().clear();
			getPresentation().addAll((Collection) newValue);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__TARGET_FLOW:
			getTargetFlow().clear();
			getTargetFlow().addAll((Collection) newValue);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__SOURCE_FLOW:
			getSourceFlow().clear();
			getSourceFlow().addAll((Collection) newValue);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__TEMPLATE_PARAMETER3:
			getTemplateParameter3().clear();
			getTemplateParameter3().addAll((Collection) newValue);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__BINDING:
			setBinding((Binding) newValue);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__COMMENT:
			getComment().clear();
			getComment().addAll((Collection) newValue);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			getElementResidence().addAll((Collection) newValue);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			getTemplateParameter().addAll((Collection) newValue);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__TEMPLATE_PARAMETER2:
			getTemplateParameter2().clear();
			getTemplateParameter2().addAll((Collection) newValue);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__STEREOTYPE:
			setStereotype((Stereotype) newValue);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__TAGGED_VALUE:
			getTaggedValue().clear();
			getTaggedValue().addAll((Collection) newValue);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__BEHAVIOR:
			getBehavior().clear();
			getBehavior().addAll((Collection) newValue);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			getClassifierRole().addAll((Collection) newValue);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__COLLABORATION:
			getCollaboration().clear();
			getCollaboration().addAll((Collection) newValue);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__PARTITION:
			getPartition().clear();
			getPartition().addAll((Collection) newValue);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__CONTAINER:
			setContainer((CompositeState) newValue);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__OUTGOING:
			getOutgoing().clear();
			getOutgoing().addAll((Collection) newValue);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__INCOMING:
			getIncoming().clear();
			getIncoming().addAll((Collection) newValue);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__ENTRY:
			setEntry((Action) newValue);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__EXIT:
			setExit((Action) newValue);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__STATE_MACHINE:
			setStateMachine((StateMachine) newValue);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__DEFERRABLE_EVENT:
			getDeferrableEvent().clear();
			getDeferrableEvent().addAll((Collection) newValue);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__INTERNAL_TRANSITION:
			getInternalTransition().clear();
			getInternalTransition().addAll((Collection) newValue);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__DO_ACTIVITY:
			setDoActivity((Action) newValue);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__CLASSIFIER_IN_STATE:
			getClassifierInState().clear();
			getClassifierInState().addAll((Collection) newValue);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__IS_CONCURRENT:
			setIsConcurrent(((Boolean) newValue).booleanValue());
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__SUBVERTEX:
			getSubvertex().clear();
			getSubvertex().addAll((Collection) newValue);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__SUBMACHINE:
			setSubmachine((StateMachine) newValue);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__IS_DYNAMIC:
			setIsDynamic(((Boolean) newValue).booleanValue());
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__DYNAMIC_ARGUMENTS:
			setDynamicArguments((ArgListsExpression) newValue);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__DYNAMIC_MULTIPLICITY:
			setDynamicMultiplicity((Multiplicity) newValue);
			return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Activity_graphsPackage.SUBACTIVITY_STATE__ELEMENT_IMPORT:
			getElementImport().clear();
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__NAME:
			setName(NAME_EDEFAULT);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__VISIBILITY:
			setVisibility(VISIBILITY_EDEFAULT);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__IS_SPECIFICATION:
			setIsSpecification(IS_SPECIFICATION_EDEFAULT);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__NAMESPACE:
			setNamespace((Namespace) null);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__CONSTRAINT:
			getConstraint().clear();
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__PRESENTATION:
			getPresentation().clear();
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__TARGET_FLOW:
			getTargetFlow().clear();
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__SOURCE_FLOW:
			getSourceFlow().clear();
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__TEMPLATE_PARAMETER3:
			getTemplateParameter3().clear();
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__BINDING:
			setBinding((Binding) null);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__COMMENT:
			getComment().clear();
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__TEMPLATE_PARAMETER2:
			getTemplateParameter2().clear();
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__STEREOTYPE:
			setStereotype((Stereotype) null);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__TAGGED_VALUE:
			getTaggedValue().clear();
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__BEHAVIOR:
			getBehavior().clear();
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__COLLABORATION:
			getCollaboration().clear();
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__PARTITION:
			getPartition().clear();
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__CONTAINER:
			setContainer((CompositeState) null);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__OUTGOING:
			getOutgoing().clear();
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__INCOMING:
			getIncoming().clear();
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__ENTRY:
			setEntry((Action) null);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__EXIT:
			setExit((Action) null);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__STATE_MACHINE:
			setStateMachine((StateMachine) null);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__DEFERRABLE_EVENT:
			getDeferrableEvent().clear();
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__INTERNAL_TRANSITION:
			getInternalTransition().clear();
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__DO_ACTIVITY:
			setDoActivity((Action) null);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__CLASSIFIER_IN_STATE:
			getClassifierInState().clear();
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__IS_CONCURRENT:
			setIsConcurrent(IS_CONCURRENT_EDEFAULT);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__SUBVERTEX:
			getSubvertex().clear();
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__SUBMACHINE:
			setSubmachine((StateMachine) null);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__IS_DYNAMIC:
			setIsDynamic(IS_DYNAMIC_EDEFAULT);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__DYNAMIC_ARGUMENTS:
			setDynamicArguments((ArgListsExpression) null);
			return;
		case Activity_graphsPackage.SUBACTIVITY_STATE__DYNAMIC_MULTIPLICITY:
			setDynamicMultiplicity((Multiplicity) null);
			return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Activity_graphsPackage.SUBACTIVITY_STATE__ELEMENT_IMPORT:
			return elementImport != null && !elementImport.isEmpty();
		case Activity_graphsPackage.SUBACTIVITY_STATE__NAME:
			return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
		case Activity_graphsPackage.SUBACTIVITY_STATE__VISIBILITY:
			return VISIBILITY_EDEFAULT == null ? visibility != null : !VISIBILITY_EDEFAULT.equals(visibility);
		case Activity_graphsPackage.SUBACTIVITY_STATE__IS_SPECIFICATION:
			return isSpecification != IS_SPECIFICATION_EDEFAULT;
		case Activity_graphsPackage.SUBACTIVITY_STATE__NAMESPACE:
			return getNamespace() != null;
		case Activity_graphsPackage.SUBACTIVITY_STATE__CLIENT_DEPENDENCY:
			return clientDependency != null && !clientDependency.isEmpty();
		case Activity_graphsPackage.SUBACTIVITY_STATE__CONSTRAINT:
			return constraint != null && !constraint.isEmpty();
		case Activity_graphsPackage.SUBACTIVITY_STATE__SUPPLIER_DEPENDENCY:
			return supplierDependency != null && !supplierDependency.isEmpty();
		case Activity_graphsPackage.SUBACTIVITY_STATE__PRESENTATION:
			return presentation != null && !presentation.isEmpty();
		case Activity_graphsPackage.SUBACTIVITY_STATE__TARGET_FLOW:
			return targetFlow != null && !targetFlow.isEmpty();
		case Activity_graphsPackage.SUBACTIVITY_STATE__SOURCE_FLOW:
			return sourceFlow != null && !sourceFlow.isEmpty();
		case Activity_graphsPackage.SUBACTIVITY_STATE__TEMPLATE_PARAMETER3:
			return templateParameter3 != null && !templateParameter3.isEmpty();
		case Activity_graphsPackage.SUBACTIVITY_STATE__BINDING:
			return binding != null;
		case Activity_graphsPackage.SUBACTIVITY_STATE__COMMENT:
			return comment != null && !comment.isEmpty();
		case Activity_graphsPackage.SUBACTIVITY_STATE__ELEMENT_RESIDENCE:
			return elementResidence != null && !elementResidence.isEmpty();
		case Activity_graphsPackage.SUBACTIVITY_STATE__TEMPLATE_PARAMETER:
			return templateParameter != null && !templateParameter.isEmpty();
		case Activity_graphsPackage.SUBACTIVITY_STATE__TEMPLATE_PARAMETER2:
			return templateParameter2 != null && !templateParameter2.isEmpty();
		case Activity_graphsPackage.SUBACTIVITY_STATE__STEREOTYPE:
			return stereotype != null;
		case Activity_graphsPackage.SUBACTIVITY_STATE__TAGGED_VALUE:
			return taggedValue != null && !taggedValue.isEmpty();
		case Activity_graphsPackage.SUBACTIVITY_STATE__BEHAVIOR:
			return behavior != null && !behavior.isEmpty();
		case Activity_graphsPackage.SUBACTIVITY_STATE__CLASSIFIER_ROLE:
			return classifierRole != null && !classifierRole.isEmpty();
		case Activity_graphsPackage.SUBACTIVITY_STATE__COLLABORATION:
			return collaboration != null && !collaboration.isEmpty();
		case Activity_graphsPackage.SUBACTIVITY_STATE__PARTITION:
			return partition != null && !partition.isEmpty();
		case Activity_graphsPackage.SUBACTIVITY_STATE__CONTAINER:
			return getContainer() != null;
		case Activity_graphsPackage.SUBACTIVITY_STATE__OUTGOING:
			return outgoing != null && !outgoing.isEmpty();
		case Activity_graphsPackage.SUBACTIVITY_STATE__INCOMING:
			return incoming != null && !incoming.isEmpty();
		case Activity_graphsPackage.SUBACTIVITY_STATE__ENTRY:
			return entry != null;
		case Activity_graphsPackage.SUBACTIVITY_STATE__EXIT:
			return exit != null;
		case Activity_graphsPackage.SUBACTIVITY_STATE__STATE_MACHINE:
			return getStateMachine() != null;
		case Activity_graphsPackage.SUBACTIVITY_STATE__DEFERRABLE_EVENT:
			return deferrableEvent != null && !deferrableEvent.isEmpty();
		case Activity_graphsPackage.SUBACTIVITY_STATE__INTERNAL_TRANSITION:
			return internalTransition != null && !internalTransition.isEmpty();
		case Activity_graphsPackage.SUBACTIVITY_STATE__DO_ACTIVITY:
			return doActivity != null;
		case Activity_graphsPackage.SUBACTIVITY_STATE__CLASSIFIER_IN_STATE:
			return classifierInState != null && !classifierInState.isEmpty();
		case Activity_graphsPackage.SUBACTIVITY_STATE__IS_CONCURRENT:
			return isConcurrent != IS_CONCURRENT_EDEFAULT;
		case Activity_graphsPackage.SUBACTIVITY_STATE__SUBVERTEX:
			return subvertex != null && !subvertex.isEmpty();
		case Activity_graphsPackage.SUBACTIVITY_STATE__SUBMACHINE:
			return submachine != null;
		case Activity_graphsPackage.SUBACTIVITY_STATE__IS_DYNAMIC:
			return isDynamic != IS_DYNAMIC_EDEFAULT;
		case Activity_graphsPackage.SUBACTIVITY_STATE__DYNAMIC_ARGUMENTS:
			return dynamicArguments != null;
		case Activity_graphsPackage.SUBACTIVITY_STATE__DYNAMIC_MULTIPLICITY:
			return dynamicMultiplicity != null;
		}
		return eDynamicIsSet(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (isDynamic: ");
		result.append(isDynamic);
		result.append(')');
		return result.toString();
	}

} // SubactivityStateImpl
