/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml14.behavioral_elements.activity_graphs.impl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.impl.EPackageImpl;

import fr.obeo.acceleo.uml14.Uml14Package;
import fr.obeo.acceleo.uml14.behavioral_elements.activity_graphs.ActionState;
import fr.obeo.acceleo.uml14.behavioral_elements.activity_graphs.ActivityGraph;
import fr.obeo.acceleo.uml14.behavioral_elements.activity_graphs.Activity_graphsFactory;
import fr.obeo.acceleo.uml14.behavioral_elements.activity_graphs.Activity_graphsPackage;
import fr.obeo.acceleo.uml14.behavioral_elements.activity_graphs.CallState;
import fr.obeo.acceleo.uml14.behavioral_elements.activity_graphs.ClassifierInState;
import fr.obeo.acceleo.uml14.behavioral_elements.activity_graphs.ObjectFlowState;
import fr.obeo.acceleo.uml14.behavioral_elements.activity_graphs.Partition;
import fr.obeo.acceleo.uml14.behavioral_elements.activity_graphs.SubactivityState;
import fr.obeo.acceleo.uml14.behavioral_elements.collaborations.CollaborationsPackage;
import fr.obeo.acceleo.uml14.behavioral_elements.collaborations.impl.CollaborationsPackageImpl;
import fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Common_behaviorPackage;
import fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.impl.Common_behaviorPackageImpl;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.State_machinesPackage;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.impl.State_machinesPackageImpl;
import fr.obeo.acceleo.uml14.behavioral_elements.use_cases.Use_casesPackage;
import fr.obeo.acceleo.uml14.behavioral_elements.use_cases.impl.Use_casesPackageImpl;
import fr.obeo.acceleo.uml14.foundation.core.CorePackage;
import fr.obeo.acceleo.uml14.foundation.core.impl.CorePackageImpl;
import fr.obeo.acceleo.uml14.foundation.data_types.Data_typesPackage;
import fr.obeo.acceleo.uml14.foundation.data_types.impl.Data_typesPackageImpl;
import fr.obeo.acceleo.uml14.impl.Uml14PackageImpl;
import fr.obeo.acceleo.uml14.model_management.Model_managementPackage;
import fr.obeo.acceleo.uml14.model_management.impl.Model_managementPackageImpl;

/**
 * <!-- begin-user-doc --> An implementation of the model <b>Package</b>. <!--
 * end-user-doc -->
 * 
 * @generated
 */
public class Activity_graphsPackageImpl extends EPackageImpl implements Activity_graphsPackage {
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass activityGraphEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass partitionEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass subactivityStateEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass actionStateEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass callStateEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass objectFlowStateEClass = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private EClass classifierInStateEClass = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the
	 * package package URI value.
	 * <p>
	 * Note: the correct way to create the package is via the static factory
	 * method {@link #init init()}, which also performs initialization of the
	 * package, or returns the registered package, if one already exists. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.activity_graphs.Activity_graphsPackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private Activity_graphsPackageImpl() {
		super(eNS_URI, Activity_graphsFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this model,
	 * and for any others upon which it depends. Simple dependencies are
	 * satisfied by calling this method on all dependent packages before doing
	 * anything else. This method drives initialization for interdependent
	 * packages directly, in parallel with this package, itself.
	 * <p>
	 * Of this package and its interdependencies, all packages which have not
	 * yet been registered by their URI values are first created and registered.
	 * The packages are then initialized in two steps: meta-model objects for
	 * all of the packages are created before any are initialized, since one
	 * package's meta-model objects may refer to those of another.
	 * <p>
	 * Invocation of this method will not affect any packages that have already
	 * been initialized. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static Activity_graphsPackage init() {
		if (isInited)
			return (Activity_graphsPackage) EPackage.Registry.INSTANCE.getEPackage(Activity_graphsPackage.eNS_URI);

		// Obtain or create and register package
		Activity_graphsPackageImpl theActivity_graphsPackage = (Activity_graphsPackageImpl) (EPackage.Registry.INSTANCE.getEPackage(eNS_URI) instanceof Activity_graphsPackageImpl ? EPackage.Registry.INSTANCE
				.getEPackage(eNS_URI)
				: new Activity_graphsPackageImpl());

		isInited = true;

		// Obtain or create and register interdependencies
		Uml14PackageImpl theUml14Package = (Uml14PackageImpl) (EPackage.Registry.INSTANCE.getEPackage(Uml14Package.eNS_URI) instanceof Uml14PackageImpl ? EPackage.Registry.INSTANCE
				.getEPackage(Uml14Package.eNS_URI) : Uml14Package.eINSTANCE);
		Model_managementPackageImpl theModel_managementPackage = (Model_managementPackageImpl) (EPackage.Registry.INSTANCE.getEPackage(Model_managementPackage.eNS_URI) instanceof Model_managementPackageImpl ? EPackage.Registry.INSTANCE
				.getEPackage(Model_managementPackage.eNS_URI)
				: Model_managementPackage.eINSTANCE);
		Data_typesPackageImpl theData_typesPackage = (Data_typesPackageImpl) (EPackage.Registry.INSTANCE.getEPackage(Data_typesPackage.eNS_URI) instanceof Data_typesPackageImpl ? EPackage.Registry.INSTANCE
				.getEPackage(Data_typesPackage.eNS_URI)
				: Data_typesPackage.eINSTANCE);
		CorePackageImpl theCorePackage = (CorePackageImpl) (EPackage.Registry.INSTANCE.getEPackage(CorePackage.eNS_URI) instanceof CorePackageImpl ? EPackage.Registry.INSTANCE
				.getEPackage(CorePackage.eNS_URI) : CorePackage.eINSTANCE);
		Common_behaviorPackageImpl theCommon_behaviorPackage = (Common_behaviorPackageImpl) (EPackage.Registry.INSTANCE.getEPackage(Common_behaviorPackage.eNS_URI) instanceof Common_behaviorPackageImpl ? EPackage.Registry.INSTANCE
				.getEPackage(Common_behaviorPackage.eNS_URI)
				: Common_behaviorPackage.eINSTANCE);
		Use_casesPackageImpl theUse_casesPackage = (Use_casesPackageImpl) (EPackage.Registry.INSTANCE.getEPackage(Use_casesPackage.eNS_URI) instanceof Use_casesPackageImpl ? EPackage.Registry.INSTANCE
				.getEPackage(Use_casesPackage.eNS_URI)
				: Use_casesPackage.eINSTANCE);
		State_machinesPackageImpl theState_machinesPackage = (State_machinesPackageImpl) (EPackage.Registry.INSTANCE.getEPackage(State_machinesPackage.eNS_URI) instanceof State_machinesPackageImpl ? EPackage.Registry.INSTANCE
				.getEPackage(State_machinesPackage.eNS_URI)
				: State_machinesPackage.eINSTANCE);
		CollaborationsPackageImpl theCollaborationsPackage = (CollaborationsPackageImpl) (EPackage.Registry.INSTANCE.getEPackage(CollaborationsPackage.eNS_URI) instanceof CollaborationsPackageImpl ? EPackage.Registry.INSTANCE
				.getEPackage(CollaborationsPackage.eNS_URI)
				: CollaborationsPackage.eINSTANCE);

		// Create package meta-data objects
		theActivity_graphsPackage.createPackageContents();
		theUml14Package.createPackageContents();
		theModel_managementPackage.createPackageContents();
		theData_typesPackage.createPackageContents();
		theCorePackage.createPackageContents();
		theCommon_behaviorPackage.createPackageContents();
		theUse_casesPackage.createPackageContents();
		theState_machinesPackage.createPackageContents();
		theCollaborationsPackage.createPackageContents();

		// Initialize created meta-data
		theActivity_graphsPackage.initializePackageContents();
		theUml14Package.initializePackageContents();
		theModel_managementPackage.initializePackageContents();
		theData_typesPackage.initializePackageContents();
		theCorePackage.initializePackageContents();
		theCommon_behaviorPackage.initializePackageContents();
		theUse_casesPackage.initializePackageContents();
		theState_machinesPackage.initializePackageContents();
		theCollaborationsPackage.initializePackageContents();

		// Mark meta-data to indicate it can't be changed
		theActivity_graphsPackage.freeze();

		return theActivity_graphsPackage;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getActivityGraph() {
		return activityGraphEClass;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getPartition() {
		return partitionEClass;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getPartition_Contents() {
		return (EReference) partitionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getSubactivityState() {
		return subactivityStateEClass;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getSubactivityState_IsDynamic() {
		return (EAttribute) subactivityStateEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getSubactivityState_DynamicArguments() {
		return (EReference) subactivityStateEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getSubactivityState_DynamicMultiplicity() {
		return (EReference) subactivityStateEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getActionState() {
		return actionStateEClass;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getActionState_IsDynamic() {
		return (EAttribute) actionStateEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getActionState_DynamicArguments() {
		return (EReference) actionStateEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getActionState_DynamicMultiplicity() {
		return (EReference) actionStateEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getCallState() {
		return callStateEClass;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getObjectFlowState() {
		return objectFlowStateEClass;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EAttribute getObjectFlowState_IsSynch() {
		return (EAttribute) objectFlowStateEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getObjectFlowState_Parameter() {
		return (EReference) objectFlowStateEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getObjectFlowState_Type() {
		return (EReference) objectFlowStateEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EClass getClassifierInState() {
		return classifierInStateEClass;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getClassifierInState_Type() {
		return (EReference) classifierInStateEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EReference getClassifierInState_InState() {
		return (EReference) classifierInStateEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Activity_graphsFactory getActivity_graphsFactory() {
		return (Activity_graphsFactory) getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package. This method is guarded to
	 * have no affect on any invocation but its first. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated)
			return;
		isCreated = true;

		// Create classes and their features
		activityGraphEClass = createEClass(ACTIVITY_GRAPH);

		partitionEClass = createEClass(PARTITION);
		createEReference(partitionEClass, PARTITION__CONTENTS);

		subactivityStateEClass = createEClass(SUBACTIVITY_STATE);
		createEAttribute(subactivityStateEClass, SUBACTIVITY_STATE__IS_DYNAMIC);
		createEReference(subactivityStateEClass, SUBACTIVITY_STATE__DYNAMIC_ARGUMENTS);
		createEReference(subactivityStateEClass, SUBACTIVITY_STATE__DYNAMIC_MULTIPLICITY);

		actionStateEClass = createEClass(ACTION_STATE);
		createEAttribute(actionStateEClass, ACTION_STATE__IS_DYNAMIC);
		createEReference(actionStateEClass, ACTION_STATE__DYNAMIC_ARGUMENTS);
		createEReference(actionStateEClass, ACTION_STATE__DYNAMIC_MULTIPLICITY);

		callStateEClass = createEClass(CALL_STATE);

		objectFlowStateEClass = createEClass(OBJECT_FLOW_STATE);
		createEAttribute(objectFlowStateEClass, OBJECT_FLOW_STATE__IS_SYNCH);
		createEReference(objectFlowStateEClass, OBJECT_FLOW_STATE__PARAMETER);
		createEReference(objectFlowStateEClass, OBJECT_FLOW_STATE__TYPE);

		classifierInStateEClass = createEClass(CLASSIFIER_IN_STATE);
		createEReference(classifierInStateEClass, CLASSIFIER_IN_STATE__TYPE);
		createEReference(classifierInStateEClass, CLASSIFIER_IN_STATE__IN_STATE);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model. This
	 * method is guarded to have no affect on any invocation but its first. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized)
			return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Obtain other dependent packages
		State_machinesPackageImpl theState_machinesPackage = (State_machinesPackageImpl) EPackage.Registry.INSTANCE.getEPackage(State_machinesPackage.eNS_URI);
		CorePackageImpl theCorePackage = (CorePackageImpl) EPackage.Registry.INSTANCE.getEPackage(CorePackage.eNS_URI);
		Data_typesPackageImpl theData_typesPackage = (Data_typesPackageImpl) EPackage.Registry.INSTANCE.getEPackage(Data_typesPackage.eNS_URI);

		// Add supertypes to classes
		activityGraphEClass.getESuperTypes().add(theState_machinesPackage.getStateMachine());
		partitionEClass.getESuperTypes().add(theCorePackage.getModelElement());
		subactivityStateEClass.getESuperTypes().add(theState_machinesPackage.getSubmachineState());
		actionStateEClass.getESuperTypes().add(theState_machinesPackage.getSimpleState());
		callStateEClass.getESuperTypes().add(this.getActionState());
		objectFlowStateEClass.getESuperTypes().add(theState_machinesPackage.getSimpleState());
		classifierInStateEClass.getESuperTypes().add(theCorePackage.getClassifier());

		// Initialize classes and features; add operations and parameters
		initEClass(activityGraphEClass, ActivityGraph.class, "ActivityGraph", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(partitionEClass, Partition.class, "Partition", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getPartition_Contents(), theCorePackage.getModelElement(), theCorePackage.getModelElement_Partition(), "contents", null, 0, -1, Partition.class, !IS_TRANSIENT, !IS_VOLATILE,
				IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(subactivityStateEClass, SubactivityState.class, "SubactivityState", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getSubactivityState_IsDynamic(), theData_typesPackage.getBoolean(), "isDynamic", null, 0, 1, SubactivityState.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE,
				!IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getSubactivityState_DynamicArguments(), theData_typesPackage.getArgListsExpression(), null, "dynamicArguments", null, 0, 1, SubactivityState.class, !IS_TRANSIENT, !IS_VOLATILE,
				IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getSubactivityState_DynamicMultiplicity(), theData_typesPackage.getMultiplicity(), null, "dynamicMultiplicity", null, 0, 1, SubactivityState.class, !IS_TRANSIENT, !IS_VOLATILE,
				IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(actionStateEClass, ActionState.class, "ActionState", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getActionState_IsDynamic(), theData_typesPackage.getBoolean(), "isDynamic", null, 0, 1, ActionState.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID,
				IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getActionState_DynamicArguments(), theData_typesPackage.getArgListsExpression(), null, "dynamicArguments", null, 0, 1, ActionState.class, !IS_TRANSIENT, !IS_VOLATILE,
				IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getActionState_DynamicMultiplicity(), theData_typesPackage.getMultiplicity(), null, "dynamicMultiplicity", null, 0, 1, ActionState.class, !IS_TRANSIENT, !IS_VOLATILE,
				IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(callStateEClass, CallState.class, "CallState", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(objectFlowStateEClass, ObjectFlowState.class, "ObjectFlowState", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getObjectFlowState_IsSynch(), theData_typesPackage.getBoolean(), "isSynch", null, 0, 1, ObjectFlowState.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE,
				!IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getObjectFlowState_Parameter(), theCorePackage.getParameter(), theCorePackage.getParameter_State(), "parameter", null, 0, -1, ObjectFlowState.class, !IS_TRANSIENT,
				!IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getObjectFlowState_Type(), theCorePackage.getClassifier(), theCorePackage.getClassifier_ObjectFlowState(), "type", null, 1, 1, ObjectFlowState.class, !IS_TRANSIENT,
				!IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(classifierInStateEClass, ClassifierInState.class, "ClassifierInState", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getClassifierInState_Type(), theCorePackage.getClassifier(), theCorePackage.getClassifier_ClassifierInState(), "type", null, 1, 1, ClassifierInState.class, !IS_TRANSIENT,
				!IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getClassifierInState_InState(), theState_machinesPackage.getState(), theState_machinesPackage.getState_ClassifierInState(), "inState", null, 1, -1, ClassifierInState.class,
				!IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
	}

} // Activity_graphsPackageImpl
