/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml14.behavioral_elements.activity_graphs.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

import fr.obeo.acceleo.uml14.behavioral_elements.activity_graphs.Activity_graphsPackage;
import fr.obeo.acceleo.uml14.behavioral_elements.activity_graphs.ObjectFlowState;
import fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Action;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.CompositeState;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.StateMachine;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.State_machinesPackage;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.impl.SimpleStateImpl;
import fr.obeo.acceleo.uml14.foundation.core.Classifier;
import fr.obeo.acceleo.uml14.foundation.core.CorePackage;
import fr.obeo.acceleo.uml14.foundation.core.Namespace;
import fr.obeo.acceleo.uml14.foundation.core.Parameter;
import fr.obeo.acceleo.uml14.foundation.core.TemplateParameter;
import fr.obeo.acceleo.uml14.foundation.data_types.VisibilityKind;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>Object Flow State</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>{@link fr.obeo.acceleo.uml14.behavioral_elements.activity_graphs.impl.ObjectFlowStateImpl#isIsSynch <em>Is Synch</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml14.behavioral_elements.activity_graphs.impl.ObjectFlowStateImpl#getParameter <em>Parameter</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml14.behavioral_elements.activity_graphs.impl.ObjectFlowStateImpl#getType <em>Type</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class ObjectFlowStateImpl extends SimpleStateImpl implements ObjectFlowState {
	/**
	 * The default value of the '{@link #isIsSynch() <em>Is Synch</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #isIsSynch()
	 * @generated
	 * @ordered
	 */
	protected static final boolean IS_SYNCH_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isIsSynch() <em>Is Synch</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #isIsSynch()
	 * @generated
	 * @ordered
	 */
	protected boolean isSynch = IS_SYNCH_EDEFAULT;

	/**
	 * The cached value of the '{@link #getParameter() <em>Parameter</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getParameter()
	 * @generated
	 * @ordered
	 */
	protected EList parameter = null;

	/**
	 * The cached value of the '{@link #getType() <em>Type</em>}' reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getType()
	 * @generated
	 * @ordered
	 */
	protected Classifier type = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected ObjectFlowStateImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected EClass eStaticClass() {
		return Activity_graphsPackage.eINSTANCE.getObjectFlowState();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean isIsSynch() {
		return isSynch;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setIsSynch(boolean newIsSynch) {
		boolean oldIsSynch = isSynch;
		isSynch = newIsSynch;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Activity_graphsPackage.OBJECT_FLOW_STATE__IS_SYNCH, oldIsSynch, isSynch));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getParameter() {
		if (parameter == null) {
			parameter = new EObjectWithInverseResolvingEList.ManyInverse(Parameter.class, this, Activity_graphsPackage.OBJECT_FLOW_STATE__PARAMETER, CorePackage.PARAMETER__STATE);
		}
		return parameter;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Classifier getType() {
		if (type != null && type.eIsProxy()) {
			Classifier oldType = type;
			type = (Classifier) eResolveProxy((InternalEObject) type);
			if (type != oldType) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, Activity_graphsPackage.OBJECT_FLOW_STATE__TYPE, oldType, type));
			}
		}
		return type;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Classifier basicGetType() {
		return type;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetType(Classifier newType, NotificationChain msgs) {
		Classifier oldType = type;
		type = newType;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Activity_graphsPackage.OBJECT_FLOW_STATE__TYPE, oldType, newType);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setType(Classifier newType) {
		if (newType != type) {
			NotificationChain msgs = null;
			if (type != null)
				msgs = ((InternalEObject) type).eInverseRemove(this, CorePackage.CLASSIFIER__OBJECT_FLOW_STATE, Classifier.class, msgs);
			if (newType != null)
				msgs = ((InternalEObject) newType).eInverseAdd(this, CorePackage.CLASSIFIER__OBJECT_FLOW_STATE, Classifier.class, msgs);
			msgs = basicSetType(newType, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Activity_graphsPackage.OBJECT_FLOW_STATE__TYPE, newType, newType));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case Activity_graphsPackage.OBJECT_FLOW_STATE__NAMESPACE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, Activity_graphsPackage.OBJECT_FLOW_STATE__NAMESPACE, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicAdd(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicAdd(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicAdd(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__PRESENTATION:
				return ((InternalEList) getPresentation()).basicAdd(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicAdd(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicAdd(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__DEFAULTED_PARAMETER:
				return ((InternalEList) getDefaultedParameter()).basicAdd(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__COMMENT:
				return ((InternalEList) getComment()).basicAdd(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicAdd(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicAdd(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__PARAMETER_TEMPLATE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, Activity_graphsPackage.OBJECT_FLOW_STATE__PARAMETER_TEMPLATE, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__STEREOTYPE:
				return ((InternalEList) getStereotype()).basicAdd(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicAdd(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__REFERENCE_TAG:
				return ((InternalEList) getReferenceTag()).basicAdd(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__TEMPLATE_ARGUMENT:
				return ((InternalEList) getTemplateArgument()).basicAdd(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicAdd(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicAdd(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicAdd(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__COLLABORATION_INSTANCE_SET:
				return ((InternalEList) getCollaborationInstanceSet()).basicAdd(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__PARTITION:
				return ((InternalEList) getPartition()).basicAdd(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicAdd(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__CONTAINER:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, Activity_graphsPackage.OBJECT_FLOW_STATE__CONTAINER, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__OUTGOING:
				return ((InternalEList) getOutgoing()).basicAdd(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__INCOMING:
				return ((InternalEList) getIncoming()).basicAdd(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__ENTRY:
				if (entry != null)
					msgs = ((InternalEObject) entry).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - Activity_graphsPackage.OBJECT_FLOW_STATE__ENTRY, null, msgs);
				return basicSetEntry((Action) otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__STATE_MACHINE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, Activity_graphsPackage.OBJECT_FLOW_STATE__STATE_MACHINE, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__DEFERRABLE_EVENT:
				return ((InternalEList) getDeferrableEvent()).basicAdd(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__INTERNAL_TRANSITION:
				return ((InternalEList) getInternalTransition()).basicAdd(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__CLASSIFIER_IN_STATE:
				return ((InternalEList) getClassifierInState()).basicAdd(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__PARAMETER:
				return ((InternalEList) getParameter()).basicAdd(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__TYPE:
				if (type != null)
					msgs = ((InternalEObject) type).eInverseRemove(this, CorePackage.CLASSIFIER__OBJECT_FLOW_STATE, Classifier.class, msgs);
				return basicSetType((Classifier) otherEnd, msgs);
			default:
				return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case Activity_graphsPackage.OBJECT_FLOW_STATE__NAMESPACE:
				return eBasicSetContainer(null, Activity_graphsPackage.OBJECT_FLOW_STATE__NAMESPACE, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicRemove(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicRemove(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicRemove(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__PRESENTATION:
				return ((InternalEList) getPresentation()).basicRemove(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicRemove(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicRemove(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__DEFAULTED_PARAMETER:
				return ((InternalEList) getDefaultedParameter()).basicRemove(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__COMMENT:
				return ((InternalEList) getComment()).basicRemove(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicRemove(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicRemove(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__PARAMETER_TEMPLATE:
				return eBasicSetContainer(null, Activity_graphsPackage.OBJECT_FLOW_STATE__PARAMETER_TEMPLATE, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__STEREOTYPE:
				return ((InternalEList) getStereotype()).basicRemove(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicRemove(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__REFERENCE_TAG:
				return ((InternalEList) getReferenceTag()).basicRemove(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__TEMPLATE_ARGUMENT:
				return ((InternalEList) getTemplateArgument()).basicRemove(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicRemove(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicRemove(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicRemove(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__COLLABORATION_INSTANCE_SET:
				return ((InternalEList) getCollaborationInstanceSet()).basicRemove(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__PARTITION:
				return ((InternalEList) getPartition()).basicRemove(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicRemove(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__CONTAINER:
				return eBasicSetContainer(null, Activity_graphsPackage.OBJECT_FLOW_STATE__CONTAINER, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__OUTGOING:
				return ((InternalEList) getOutgoing()).basicRemove(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__INCOMING:
				return ((InternalEList) getIncoming()).basicRemove(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__ENTRY:
				return basicSetEntry(null, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__STATE_MACHINE:
				return eBasicSetContainer(null, Activity_graphsPackage.OBJECT_FLOW_STATE__STATE_MACHINE, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__DEFERRABLE_EVENT:
				return ((InternalEList) getDeferrableEvent()).basicRemove(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__INTERNAL_TRANSITION:
				return ((InternalEList) getInternalTransition()).basicRemove(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__CLASSIFIER_IN_STATE:
				return ((InternalEList) getClassifierInState()).basicRemove(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__PARAMETER:
				return ((InternalEList) getParameter()).basicRemove(otherEnd, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__TYPE:
				return basicSetType(null, msgs);
			default:
				return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
		if (eContainerFeatureID >= 0) {
			switch (eContainerFeatureID) {
			case Activity_graphsPackage.OBJECT_FLOW_STATE__NAMESPACE:
				return eContainer.eInverseRemove(this, CorePackage.NAMESPACE__OWNED_ELEMENT, Namespace.class, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__PARAMETER_TEMPLATE:
				return eContainer.eInverseRemove(this, CorePackage.TEMPLATE_PARAMETER__PARAMETER, TemplateParameter.class, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__CONTAINER:
				return eContainer.eInverseRemove(this, State_machinesPackage.COMPOSITE_STATE__SUBVERTEX, CompositeState.class, msgs);
			case Activity_graphsPackage.OBJECT_FLOW_STATE__STATE_MACHINE:
				return eContainer.eInverseRemove(this, State_machinesPackage.STATE_MACHINE__TOP, StateMachine.class, msgs);
			default:
				return eDynamicBasicRemoveFromContainer(msgs);
			}
		}
		return eContainer.eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Activity_graphsPackage.OBJECT_FLOW_STATE__NAME:
			return getName();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__VISIBILITY:
			return getVisibility();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__IS_SPECIFICATION:
			return isIsSpecification() ? Boolean.TRUE : Boolean.FALSE;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__NAMESPACE:
			return getNamespace();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__CLIENT_DEPENDENCY:
			return getClientDependency();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__CONSTRAINT:
			return getConstraint();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__SUPPLIER_DEPENDENCY:
			return getSupplierDependency();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__PRESENTATION:
			return getPresentation();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__TARGET_FLOW:
			return getTargetFlow();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__SOURCE_FLOW:
			return getSourceFlow();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__DEFAULTED_PARAMETER:
			return getDefaultedParameter();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__COMMENT:
			return getComment();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__ELEMENT_RESIDENCE:
			return getElementResidence();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__TEMPLATE_PARAMETER:
			return getTemplateParameter();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__PARAMETER_TEMPLATE:
			return getParameterTemplate();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__STEREOTYPE:
			return getStereotype();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__TAGGED_VALUE:
			return getTaggedValue();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__REFERENCE_TAG:
			return getReferenceTag();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__TEMPLATE_ARGUMENT:
			return getTemplateArgument();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__BEHAVIOR:
			return getBehavior();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__CLASSIFIER_ROLE:
			return getClassifierRole();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__COLLABORATION:
			return getCollaboration();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__COLLABORATION_INSTANCE_SET:
			return getCollaborationInstanceSet();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__PARTITION:
			return getPartition();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__ELEMENT_IMPORT:
			return getElementImport();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__CONTAINER:
			return getContainer();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__OUTGOING:
			return getOutgoing();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__INCOMING:
			return getIncoming();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__ENTRY:
			return getEntry();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__STATE_MACHINE:
			return getStateMachine();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__DEFERRABLE_EVENT:
			return getDeferrableEvent();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__INTERNAL_TRANSITION:
			return getInternalTransition();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__CLASSIFIER_IN_STATE:
			return getClassifierInState();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__IS_SYNCH:
			return isIsSynch() ? Boolean.TRUE : Boolean.FALSE;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__PARAMETER:
			return getParameter();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__TYPE:
			if (resolve)
				return getType();
			return basicGetType();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Activity_graphsPackage.OBJECT_FLOW_STATE__NAME:
			setName((String) newValue);
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__VISIBILITY:
			setVisibility((VisibilityKind) newValue);
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__IS_SPECIFICATION:
			setIsSpecification(((Boolean) newValue).booleanValue());
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__NAMESPACE:
			setNamespace((Namespace) newValue);
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			getClientDependency().addAll((Collection) newValue);
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__CONSTRAINT:
			getConstraint().clear();
			getConstraint().addAll((Collection) newValue);
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			getSupplierDependency().addAll((Collection) newValue);
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__PRESENTATION:
			getPresentation().clear();
			getPresentation().addAll((Collection) newValue);
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__TARGET_FLOW:
			getTargetFlow().clear();
			getTargetFlow().addAll((Collection) newValue);
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__SOURCE_FLOW:
			getSourceFlow().clear();
			getSourceFlow().addAll((Collection) newValue);
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__DEFAULTED_PARAMETER:
			getDefaultedParameter().clear();
			getDefaultedParameter().addAll((Collection) newValue);
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__COMMENT:
			getComment().clear();
			getComment().addAll((Collection) newValue);
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			getElementResidence().addAll((Collection) newValue);
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			getTemplateParameter().addAll((Collection) newValue);
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__PARAMETER_TEMPLATE:
			setParameterTemplate((TemplateParameter) newValue);
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__STEREOTYPE:
			getStereotype().clear();
			getStereotype().addAll((Collection) newValue);
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__TAGGED_VALUE:
			getTaggedValue().clear();
			getTaggedValue().addAll((Collection) newValue);
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__REFERENCE_TAG:
			getReferenceTag().clear();
			getReferenceTag().addAll((Collection) newValue);
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__TEMPLATE_ARGUMENT:
			getTemplateArgument().clear();
			getTemplateArgument().addAll((Collection) newValue);
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__BEHAVIOR:
			getBehavior().clear();
			getBehavior().addAll((Collection) newValue);
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			getClassifierRole().addAll((Collection) newValue);
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__COLLABORATION:
			getCollaboration().clear();
			getCollaboration().addAll((Collection) newValue);
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__COLLABORATION_INSTANCE_SET:
			getCollaborationInstanceSet().clear();
			getCollaborationInstanceSet().addAll((Collection) newValue);
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__PARTITION:
			getPartition().clear();
			getPartition().addAll((Collection) newValue);
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__ELEMENT_IMPORT:
			getElementImport().clear();
			getElementImport().addAll((Collection) newValue);
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__CONTAINER:
			setContainer((CompositeState) newValue);
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__OUTGOING:
			getOutgoing().clear();
			getOutgoing().addAll((Collection) newValue);
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__INCOMING:
			getIncoming().clear();
			getIncoming().addAll((Collection) newValue);
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__ENTRY:
			setEntry((Action) newValue);
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__STATE_MACHINE:
			setStateMachine((StateMachine) newValue);
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__DEFERRABLE_EVENT:
			getDeferrableEvent().clear();
			getDeferrableEvent().addAll((Collection) newValue);
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__INTERNAL_TRANSITION:
			getInternalTransition().clear();
			getInternalTransition().addAll((Collection) newValue);
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__CLASSIFIER_IN_STATE:
			getClassifierInState().clear();
			getClassifierInState().addAll((Collection) newValue);
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__IS_SYNCH:
			setIsSynch(((Boolean) newValue).booleanValue());
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__PARAMETER:
			getParameter().clear();
			getParameter().addAll((Collection) newValue);
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__TYPE:
			setType((Classifier) newValue);
			return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Activity_graphsPackage.OBJECT_FLOW_STATE__NAME:
			setName(NAME_EDEFAULT);
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__VISIBILITY:
			setVisibility(VISIBILITY_EDEFAULT);
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__IS_SPECIFICATION:
			setIsSpecification(IS_SPECIFICATION_EDEFAULT);
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__NAMESPACE:
			setNamespace((Namespace) null);
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__CONSTRAINT:
			getConstraint().clear();
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__PRESENTATION:
			getPresentation().clear();
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__TARGET_FLOW:
			getTargetFlow().clear();
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__SOURCE_FLOW:
			getSourceFlow().clear();
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__DEFAULTED_PARAMETER:
			getDefaultedParameter().clear();
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__COMMENT:
			getComment().clear();
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__PARAMETER_TEMPLATE:
			setParameterTemplate((TemplateParameter) null);
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__STEREOTYPE:
			getStereotype().clear();
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__TAGGED_VALUE:
			getTaggedValue().clear();
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__REFERENCE_TAG:
			getReferenceTag().clear();
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__TEMPLATE_ARGUMENT:
			getTemplateArgument().clear();
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__BEHAVIOR:
			getBehavior().clear();
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__COLLABORATION:
			getCollaboration().clear();
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__COLLABORATION_INSTANCE_SET:
			getCollaborationInstanceSet().clear();
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__PARTITION:
			getPartition().clear();
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__ELEMENT_IMPORT:
			getElementImport().clear();
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__CONTAINER:
			setContainer((CompositeState) null);
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__OUTGOING:
			getOutgoing().clear();
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__INCOMING:
			getIncoming().clear();
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__ENTRY:
			setEntry((Action) null);
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__STATE_MACHINE:
			setStateMachine((StateMachine) null);
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__DEFERRABLE_EVENT:
			getDeferrableEvent().clear();
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__INTERNAL_TRANSITION:
			getInternalTransition().clear();
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__CLASSIFIER_IN_STATE:
			getClassifierInState().clear();
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__IS_SYNCH:
			setIsSynch(IS_SYNCH_EDEFAULT);
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__PARAMETER:
			getParameter().clear();
			return;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__TYPE:
			setType((Classifier) null);
			return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Activity_graphsPackage.OBJECT_FLOW_STATE__NAME:
			return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
		case Activity_graphsPackage.OBJECT_FLOW_STATE__VISIBILITY:
			return visibility != VISIBILITY_EDEFAULT;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__IS_SPECIFICATION:
			return isSpecification != IS_SPECIFICATION_EDEFAULT;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__NAMESPACE:
			return getNamespace() != null;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__CLIENT_DEPENDENCY:
			return clientDependency != null && !clientDependency.isEmpty();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__CONSTRAINT:
			return constraint != null && !constraint.isEmpty();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__SUPPLIER_DEPENDENCY:
			return supplierDependency != null && !supplierDependency.isEmpty();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__PRESENTATION:
			return presentation != null && !presentation.isEmpty();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__TARGET_FLOW:
			return targetFlow != null && !targetFlow.isEmpty();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__SOURCE_FLOW:
			return sourceFlow != null && !sourceFlow.isEmpty();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__DEFAULTED_PARAMETER:
			return defaultedParameter != null && !defaultedParameter.isEmpty();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__COMMENT:
			return comment != null && !comment.isEmpty();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__ELEMENT_RESIDENCE:
			return elementResidence != null && !elementResidence.isEmpty();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__TEMPLATE_PARAMETER:
			return templateParameter != null && !templateParameter.isEmpty();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__PARAMETER_TEMPLATE:
			return getParameterTemplate() != null;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__STEREOTYPE:
			return stereotype != null && !stereotype.isEmpty();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__TAGGED_VALUE:
			return taggedValue != null && !taggedValue.isEmpty();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__REFERENCE_TAG:
			return referenceTag != null && !referenceTag.isEmpty();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__TEMPLATE_ARGUMENT:
			return templateArgument != null && !templateArgument.isEmpty();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__BEHAVIOR:
			return behavior != null && !behavior.isEmpty();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__CLASSIFIER_ROLE:
			return classifierRole != null && !classifierRole.isEmpty();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__COLLABORATION:
			return collaboration != null && !collaboration.isEmpty();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__COLLABORATION_INSTANCE_SET:
			return collaborationInstanceSet != null && !collaborationInstanceSet.isEmpty();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__PARTITION:
			return partition != null && !partition.isEmpty();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__ELEMENT_IMPORT:
			return elementImport != null && !elementImport.isEmpty();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__CONTAINER:
			return getContainer() != null;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__OUTGOING:
			return outgoing != null && !outgoing.isEmpty();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__INCOMING:
			return incoming != null && !incoming.isEmpty();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__ENTRY:
			return entry != null;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__STATE_MACHINE:
			return getStateMachine() != null;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__DEFERRABLE_EVENT:
			return deferrableEvent != null && !deferrableEvent.isEmpty();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__INTERNAL_TRANSITION:
			return internalTransition != null && !internalTransition.isEmpty();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__CLASSIFIER_IN_STATE:
			return classifierInState != null && !classifierInState.isEmpty();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__IS_SYNCH:
			return isSynch != IS_SYNCH_EDEFAULT;
		case Activity_graphsPackage.OBJECT_FLOW_STATE__PARAMETER:
			return parameter != null && !parameter.isEmpty();
		case Activity_graphsPackage.OBJECT_FLOW_STATE__TYPE:
			return type != null;
		}
		return eDynamicIsSet(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (isSynch: ");
		result.append(isSynch);
		result.append(')');
		return result.toString();
	}

} // ObjectFlowStateImpl
